parse arg fn               -- get file name
s = .stream~new(fn)~~open("read")
jsonData = s~charIn(1,s~chars)   -- read entire file
s~close
j = .json~new              -- create a JSON instance
o =  j~fromJson(jsonData)  -- let it unencode the data
call dumpJsonData o        -- show data
say
say "---"
say j~toJson(o)            -- turn into JSON

::requires "json.cls"      -- get access to the JSON class

::routine dumpJsonData     -- dump the ooRexx collection
   use arg o, level=0, suffix=""
   if o~isA(.collection) then
   do
      items = o~items
      isMap = o~isA(.mapCollection)
      say "  "~copies(level) || isMap~?("{","[")
      indent="  "~copies(level+1)
      do counter c idx over o~allIndexes~sort
         suffix = (c=items)~?("",",")
         v=o[idx]
         if v~isA(.collection) then
         do
             if isMap then say indent || pp(idx)":"
             call dumpJsonData v,level+1, suffix
             say suffix
         end
         else say indent || isMap~?(pp(idx)"=","") || pp(v) || suffix
      end
      .output~charOut("  "~copies(level) || isMap~?("}","]") || suffix)
   end

::routine pp            -- enclose value in brackets
  if arg(1)~isNil then return "null"
  return  '"' || arg(1)~changeStr('"','\"') || '"'